;PROGRAM PRO OVLADANI 9-TI LED na portu P1 a brane P3.7 LED R-G-B
;ZAPOJENI VYVODU:LED-R
;		LED-G
;		LED-B
;SPINANI LED PROTI ZEMI
;9X PWM,ZAKLADNI PROGRAM-PALETA,MEXICKA A EXICKA
;PROCESOR AT89C2051
;KRYSTAL 2,000MHz
;
;JIRI BLECHA 24.12.2005


	$MODxx51
DSEG
PWM_COUNT	EQU R4
RED1		EQU 90D		;REGISTRY PRO POTREBU PWM REGULACE JASU JEDNOTLIVZCH LED
GREEN1		EQU 91D
BLUE1		EQU 92D
RED2		EQU 93D
GREEN2		EQU 94D
BLUE2		EQU 95D
RED3		EQU 96D
GREEN3		EQU 97D
BLUE3		EQU 98D

SET_DELAY	EQU 99D


SET_RED1	EQU 100D	;PREDNASTEVENI JASU LED (0=VYPNUTO,255=ZAPNUTO)
SET_GREEN1	EQU 101D
SET_BLUE1	EQU 102D
SET_RED2	EQU 103D
SET_GREEN2	EQU 104D
SET_BLUE2	EQU 105D
SET_RED3	EQU 106D
SET_GREEN3	EQU 107D
SET_BLUE3	EQU 108D

FIRE_REG	EQU 109D
DSEG AT 110D
STACK:		DS 10D

B_RED1		BIT 0H		;BITY PRO POTREBU PWM
B_GREEN1	BIT 1H
B_BLUE1		BIT 2H
B_RED2		BIT 3H
B_GREEN2	BIT 4H
B_BLUE2		BIT 5H
B_RED3		BIT 6H
B_GREEN3	BIT 7H
B_BLUE3		BIT 8H



CSEG
	ORG 0H
	JMP START

	ORG 0BH
	JMP INT_PWM





CITAC		EQU 100D
PREDVOLBA  	EQU 101D



	ORG 100H
;****************************************
;*	PRERUSENI-OBSLUHA		*
;****************************************
INT_PWM:
	PUSH ACC
	DJNZ PWM_COUNT,I_CONTINUE	;RESET PWM IF PWM_COUNT  = 0
	CLR TR0	
	CLR ET0
	MOV P1,#0H			;SW_OFF ALL LED
	CLR P3.7
	MOV RED1,SET_RED1		;UPDATE BUFEER
	MOV GREEN1,SET_GREEN1		;	.
	MOV BLUE1,SET_BLUE1		;	.

	MOV RED2,SET_RED2		;	.
	MOV GREEN2,SET_GREEN2		;	.
	MOV BLUE2,SET_BLUE2		;	.

	MOV RED3,SET_RED3		;	.
	MOV GREEN3,SET_GREEN3		;	.
	MOV BLUE3,SET_BLUE3		;	.
					;SW_ON DEFINE LED IF IS NEEDED

I_R1:	MOV A,RED1
	JZ	I_G1
	SETB P1.0	;RED	
I_G1:	MOV A,GREEN1
	JZ	I_B1
	SETB P1.1	;GREEN
I_B1:	MOV A,BLUE1
	JZ	I_R2
	SETB P1.2	;BLUE
I_R2:	MOV A,RED2
	JZ	I_G2
	SETB P1.3	;RED
I_G2:	MOV A,GREEN2
	JZ	I_B2
	SETB P1.4	;GREEN
I_B2:	MOV A,BLUE2
	JZ	I_R3
	SETB P1.5	;BLUE
I_R3:	MOV A,RED3
	JZ	I_G3
	SETB P1.6	;RED
I_G3:	MOV A,GREEN3
	JZ	I_B3
	SETB P1.7	;GREEN
I_B3:	MOV A,BLUE3
	JZ	I_END
	SETB P3.7	;BLUE

I_END:	SETB TR0
	SETB ET0
	MOV PWM_COUNT,#0FFH	;RESET PWM COUNT
	POP ACC			;REFRESH ACC
	RETI


I_CONTINUE:
	DJNZ RED1,I_SKIP_RED1
	CLR	P1.0
I_SKIP_RED1:
	DJNZ GREEN1,I_SKIP_GREEN1
	CLR	P1.1
I_SKIP_GREEN1:
	DJNZ BLUE1,I_SKIP_BLUE1
	CLR	P1.2
I_SKIP_BLUE1:
	DJNZ RED2,I_SKIP_RED2
	CLR 	P1.3
I_SKIP_RED2:
	DJNZ GREEN2,I_SKIP_GREEN2
	CLR 	P1.4
I_SKIP_GREEN2:
	DJNZ BLUE2,I_SKIP_BLUE2
	CLR 	P1.5
I_SKIP_BLUE2:
	DJNZ RED3,I_SKIP_RED3
	CLR 	P1.6
I_SKIP_RED3:
	DJNZ GREEN3,I_SKIP_GREEN3
	CLR 	P1.7
I_SKIP_GREEN3:
	DJNZ BLUE3,I_SKIP_BLUE3
	CLR 	P3.7
I_SKIP_BLUE3:
	POP ACC
	RETI
;****************************************

START:	MOV TMOD,#00000010B	;T0...8BITOVY TIMER RELOAD
	;MOV TCON,#00010000B	;SPUSTIT T0
	SETB TR0
	MOV SP,#STACK
	MOV TH0,#255D
	MOV TL0,#255D
	MOV PWM_COUNT,#255D
	MOV P1,#0H		;SW OFF ALL LED
	CLR P3.7
	SETB EA
	SETB ET0


	

LJMP PALETA	
	ACALL RST_COLOR

;	JB P3.2,$
	ACALL STEP

POKUS:	MOV SET_RED1,#0FFH
	MOV SET_RED2,#0H
	MOV SET_RED3,#0H
;	JB P3.2,$
	ACALL STEP


	MOV SET_RED1,#0H
	MOV SET_RED2,#0FFH
	MOV SET_RED3,#0H
;	JB P3.2,$
	ACALL STEP

	MOV SET_RED1,#0H
	MOV SET_RED2,#0H
	MOV SET_RED3,#0FFH
;	JB P3.2,$
	ACALL STEP

	MOV SET_RED1,#0H
	MOV SET_RED2,#0H
	MOV SET_RED3,#0H
	MOV SET_GREEN1,#0FFH
	MOV SET_RED2,#0FFH
	MOV SET_BLUE3,#0FFH
;	JB P3.2,$
	ACALL STEP




PALETA:	
	ACALL RST_COLOR
	MOV A,#0D
P_0:	ACALL DELAY_255		;R=0->255,G=0,B=0
	MOV SET_RED1,A
	MOV SET_RED2,A
	MOV SET_RED3,A
	INC 	A
	JZ	P_1
	LJMP	P_0




ACALL WAIT	
P_1:	ACALL DELAY_255		;R=255,G=0->255.B=0
	INC SET_GREEN1
	MOV A,SET_GREEN1
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	CPL A
	JZ $+5
	LJMP P_1
ACALL WAIT
P_2:	ACALL DELAY_255		;R=255->0,G=255.B=0
	NOP
	NOP
	NOP
	NOP
	MOV SET_RED2,SET_RED1
	MOV SET_RED3,SET_RED1
	DJNZ SET_RED1,P_2
ACALL WAIT
P_3:	ACALL DELAY_255		;R=0,G=255.B=0->255
	INC SET_BLUE1
	MOV A,SET_BLUE1
	MOV SET_BLUE2,A
	MOV SET_BLUE3,A
	CPL A
	JZ $+5
	LJMP P_3
ACALL WAIT
P_4:	ACALL DELAY_255		;R=0,G=255->0.B=255
	NOP
	NOP
	NOP
	NOP
	MOV SET_GREEN2,SET_GREEN1
	MOV SET_GREEN3,SET_GREEN1
	DJNZ SET_GREEN1,P_4
ACALL WAIT
P_5:	ACALL DELAY_255		;R=0->255,G=0.B=255
	INC SET_RED1
	MOV A,SET_RED1
	MOV SET_RED2,A
	MOV SET_RED3,A
	CPL A
	JZ $+5
	LJMP P_5
ACALL WAIT
P_6:	ACALL DELAY_255		;R=255,G=0->255.B=255
	INC SET_GREEN1
	MOV A,SET_GREEN1
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	CPL A
	JZ $+5
	LJMP P_6
P_END:	ACALL DELAY_255
	DEC SET_BLUE1
	MOV SET_BLUE2,SET_BLUE1
	MOV SET_BLUE3,SET_BLUE1
	DEC SET_GREEN1
	MOV SET_GREEN2,SET_GREEN1
	MOV SET_GREEN3,SET_GREEN1
	MOV SET_RED2,SET_RED1
	MOV SET_RED3,SET_RED1
	DJNZ SET_RED1,P_END
	ACALL WAIT
	ACALL WAIT

;	LJMP PALETA

	MOV SET_DELAY,#10
MEXICKA:
	ACALL RST_COLOR
	
	MOV A,#0
MEX_1:	ACALL DELAY		;R1=0->255,OTHER=0
	MOV SET_RED1,A
	INC 	A
	JZ	MEX_2R
	LJMP	MEX_1
MEX_2R:	ACALL DELAY		;R1=255->0,R2=0->255,R3=0,OTHER=0
	MOV A,SET_RED1
	CPL A
	MOV SET_RED2,A
	DJNZ SET_RED1,MEX_2R

MEX_3R:	ACALL DELAY		;R1=0,R2=255->0,R3=0->255,OTHER=0
	MOV A,SET_RED2
	CPL A
	MOV SET_RED3,A
	DJNZ SET_RED2,MEX_3R

MEX_4R:	ACALL DELAY		;Y1=0->255,R2=0,R3=255->0,OTHER=0
	MOV A,SET_RED3
	CPL A
	MOV SET_RED1,A
	MOV SET_GREEN1,SET_RED1	;PEPARE TO YELLOW
	DJNZ SET_RED3,MEX_4R
	
;ACALL STEP

MEX_2Y:	ACALL DELAY		;Y1=255->0,Y2=0->255,Y3=0,OTHER=0
	MOV A,SET_RED1
	MOV SET_GREEN1,SET_RED1
	CPL A
	MOV SET_RED2,A
	MOV SET_GREEN2,SET_RED2
	DJNZ SET_RED1,MEX_2Y

MEX_3Y:	ACALL DELAY		;Y1=0,Y2=255->0,Y3=0->255,OTHER=0
	MOV A,SET_RED2
	MOV SET_GREEN2,SET_RED2
	CPL A
	MOV SET_RED3,A
	MOV SET_GREEN3,SET_RED3
	DJNZ SET_RED2,MEX_3Y

MEX_4Y:	ACALL DELAY		;G1=0->255,Y2=0,Y3=255->0,OTHER=0
	MOV A,SET_GREEN3
	MOV SET_RED3,SET_GREEN3
	CPL A
	MOV SET_GREEN1,A
	DJNZ SET_GREEN3,MEX_4Y

;ACALL STEP

MEX_2G:	ACALL DELAY		;G1=255->0,G2=0->255,G3=0,OTHER=0
	MOV A,SET_GREEN1
	CPL A
	MOV SET_GREEN2,A
	DJNZ SET_GREEN1,MEX_2G

MEX_3G:	ACALL DELAY		;G1=0,G2=255->0,G3=0->255,OTHER=0
	MOV A,SET_GREEN2
	CPL A
	MOV SET_GREEN3,A
	DJNZ SET_GREEN2,MEX_3G

MEX_4G:	ACALL DELAY		;G1=0->255,G2=0,G3=255->0,OTHER=0
	MOV A,SET_GREEN3
	CPL A
	MOV SET_GREEN1,A
	MOV SET_BLUE1,SET_GREEN1	;PREPRE TO TURQUISE
	DJNZ SET_GREEN3,MEX_4G

;ACALL STEP

MEX_2T:	ACALL DELAY		;T1=255->0,T2=0->255,T3=0,OTHER=0
	MOV A,SET_GREEN1
	MOV SET_BLUE1,SET_GREEN1
	CPL A
	MOV SET_GREEN2,A
	MOV SET_BLUE2,SET_GREEN2
	DJNZ SET_GREEN1,MEX_2T

MEX_3T:	ACALL DELAY		;T1=0,T2=255->0,T3=0->255,OTHER=0
	MOV A,SET_GREEN2
	MOV SET_BLUE2,SET_GREEN2
	CPL A
	MOV SET_GREEN3,A
	MOV SET_BLUE3,SET_GREEN3
	DJNZ SET_GREEN2,MEX_3T

MEX_4T:	ACALL DELAY		;T1=0->255,T2=0,T3=255->0,OTHER=0
	MOV A,SET_BLUE3
	MOV SET_GREEN3,SET_BLUE3
	CPL A
	MOV SET_BLUE1,A
	DJNZ SET_BLUE3,MEX_4T

;ACALL STEP

MEX_2B:	ACALL DELAY		;G1=255->0,G2=0->255,G3=0,OTHER=0
	MOV A,SET_BLUE1
	CPL A
	MOV SET_BLUE2,A
	DJNZ SET_BLUE1,MEX_2B

MEX_3B:	ACALL DELAY		;G1=0,G2=255->0,G3=0->255,OTHER=0
	MOV A,SET_BLUE2
	CPL A
	MOV SET_BLUE3,A
	DJNZ SET_BLUE2,MEX_3B

MEX_4B:	ACALL DELAY		;G1=0->255,G2=0,G3=255->0,OTHER=0
	MOV A,SET_BLUE3
	CPL A
;	MOV SET_BLUE1,A
	NOP
	DJNZ SET_BLUE3,MEX_4B

	DJNZ SET_DELAY,JMP_MEX

	JMP EXICKA_ST
JMP_MEX:
	JMP MEXICKA

EXICKA_ST:
	MOV SET_DELAY,#10
EXICKA:
	ACALL RST_COLOR
	
	MOV A,#0
EX_0:	ACALL DELAY_10		;R1=0->255,OTHER=0
	MOV SET_RED1,A
	INC 	A
	JZ	EX_1R
	LJMP	EX_0

EX_1R:	ACALL DELAY_10		;R1=255,R2=0->255,OTHER=0
	MOV SET_RED2,A
	INC 	A
	JZ	EX_2R
	LJMP	EX_1R


EX_2R:	ACALL DELAY_10		;R1=255->0,R2=255,R3=0->255,OTHER=0
	MOV A,SET_RED1
	CPL A
	MOV SET_RED3,A
	DJNZ SET_RED1,EX_2R

EX_3R:	ACALL DELAY_10		;R1=0->255,R2=255->0,R3=255,OTHER=0
	MOV A,SET_RED2
	CPL A
	MOV SET_RED1,A
	DJNZ SET_RED2,EX_3R

EX_4R:	ACALL DELAY_10		;R1=255,Y2=0->255,R3=255->0,OTHER=0
	MOV A,SET_RED3
	CPL A
	MOV SET_RED2,A
	MOV SET_GREEN2,SET_RED2	;PEPARE TO YELLOW
	DJNZ SET_RED3,EX_4R
	
;ACALL STEP

EX_2Y:	ACALL DELAY_10		;Y1=255->0,Y2=255,Y3=0->255,OTHER=0
	MOV A,SET_RED1
	MOV SET_GREEN1,SET_RED1
	CPL A
	MOV SET_RED3,A
	MOV SET_GREEN3,SET_RED3
	DJNZ SET_RED1,EX_2Y

EX_3Y:	ACALL DELAY_10		;Y1=0->255,Y2=255->0,Y3=255,OTHER=0
	MOV A,SET_RED2
	MOV SET_GREEN2,SET_RED2
	CPL A
	MOV SET_RED1,A
	MOV SET_GREEN1,SET_RED1
	DJNZ SET_RED2,EX_3Y

EX_4Y:	ACALL DELAY_10		;Y1=255,G2=0->255,Y3=255->0,OTHER=0
	MOV A,SET_GREEN3
	MOV SET_RED3,SET_GREEN3
	CPL A
	MOV SET_GREEN2,A
	DJNZ SET_GREEN3,EX_4Y

;ACALL STEP

EX_2G:	ACALL DELAY_10		;Y1=255->0,G2=0->255,G3=0,OTHER=0
	MOV A,SET_GREEN1
	MOV SET_RED1,SET_GREEN1
	CPL A
	MOV SET_GREEN3,A
	DJNZ SET_GREEN1,EX_2G

EX_3G:	ACALL DELAY_10		;G1=0->255,G2=255->0,G3=255,OTHER=0
	MOV A,SET_GREEN2
	CPL A
	MOV SET_GREEN1,A
	DJNZ SET_GREEN2,EX_3G

EX_4G:	ACALL DELAY_10		;G1=255,T2=0->255,G3=255->0,OTHER=0
	MOV A,SET_GREEN3
	CPL A
	MOV SET_GREEN2,A
	MOV SET_BLUE2,SET_GREEN2	;PREPRE TO TURQUISE
	DJNZ SET_GREEN3,EX_4G

;ACALL STEP

EX_2T:	ACALL DELAY_10		;G1=255->0,T2=255,T3=0->255,OTHER=0
	MOV A,SET_GREEN1
	MOV SET_BLUE1,SET_GREEN1
	CPL A
	MOV SET_GREEN3,A
	MOV SET_BLUE3,SET_GREEN3
	DJNZ SET_GREEN1,EX_2T

EX_3T:	ACALL DELAY_10		;T1=0->255,T2=255->0,T3=255,OTHER=0
	MOV A,SET_GREEN2
	MOV SET_BLUE2,SET_GREEN2
	CPL A
	MOV SET_GREEN1,A
	MOV SET_BLUE1,SET_GREEN1
	DJNZ SET_GREEN2,EX_3T

EX_4T:	ACALL DELAY_10		;T1=255,B2=0->255,T3=255->0,OTHER=0
	MOV A,SET_BLUE3
	MOV SET_GREEN3,SET_BLUE3
	CPL A
	MOV SET_BLUE2,A
	DJNZ SET_BLUE3,EX_4T

;ACALL STEP

EX_2B:	ACALL DELAY_10		;B1=255->0,B2=255,B3=0->255,OTHER=0
	MOV A,SET_BLUE1
	CPL A
	MOV SET_BLUE3,A
	DJNZ SET_BLUE1,EX_2B

EX_3B:	ACALL DELAY_10		;B1=0->255,B2=255->0,B3=255,OTHER=0
	MOV A,SET_BLUE2
	CPL A
	MOV SET_BLUE1,A
	DJNZ SET_BLUE2,EX_3B

EX_4B:	ACALL DELAY_10		;B1=255,B2=0->255,B3=255->0,OTHER=0
	MOV A,SET_BLUE3
	CPL A
;	MOV SET_BLUE1,A
	NOP
	DJNZ SET_BLUE3,EX_4B

	DJNZ SET_DELAY,JMP_EX

	JMP FIRE_ST
JMP_EX:
	JMP EXICKA



	JMP PALETA


FIRE_ST: 
FIRE:	ACALL RST_COLOR

	MOV A,#0FFH
	
FIRE_R:	CPL A
	MOV SET_RED1,A	
	MOV SET_RED2,A
	MOV SET_RED3,A
	CPL A
	ACALL DELAY_255
	DJNZ ACC,FIRE_R

FIRE_GR:
	MOV FIRE_REG,#5
	MOV A,#0FFH
FIRE_G:	
	CPL A
	MOV SET_GREEN1,A	
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	CPL A
	ACALL DELAY_255
	DJNZ ACC,FIRE_G
	MOV A,#0FFH
FIRE_G1:
	
	MOV SET_GREEN1,A	
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	ACALL DELAY_255
	DJNZ ACC,FIRE_G1
	MOV A,#0FFH
	DJNZ FIRE_REG,FIRE_G

IRE_ST: 
IRE:	ACALL RST_COLOR

	MOV A,#0FFH
	
IRE_R:	CPL A
	MOV SET_RED1,A	
	MOV SET_RED2,A
	MOV SET_RED3,A
	CPL A
	ACALL DELAY_30
	DJNZ ACC,IRE_R

IRE_GR:
	MOV FIRE_REG,#15
	MOV A,#0FFH
IRE_G:	
	CPL A
	MOV SET_GREEN1,A	
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	CPL A
	ACALL DELAY_30
	DJNZ ACC,IRE_G
	MOV A,#0FFH
IRE_G1:
	
	MOV SET_GREEN1,A	
	MOV SET_GREEN2,A
	MOV SET_GREEN3,A
	ACALL DELAY_30
	DJNZ ACC,IRE_G1
	MOV A,#0FFH
	DJNZ FIRE_REG,IRE_G



	JMP PALETA



RST_COLOR:
	CLR TR0
	MOV SET_RED1,#0H
	MOV SET_RED2,#0H
	MOV SET_RED3,#0H

	MOV SET_GREEN1,#0H
	MOV SET_GREEN2,#0H
	MOV SET_GREEN3,#0H

	MOV SET_BLUE1,#0H
	MOV SET_BLUE2,#0H
	MOV SET_BLUE3,#0H
	SETB TR0
	RET


STEP:	CPL P3.5
	JB P3.2,STEP
	NOP
NOP
NOP
NOP
	JNB P3.2,$
	RET

WAIT:	CPL P3.0
	MOV R0,#255D
WAIT1:	MOV R1,#150D
	DJNZ R1,$
	DJNZ R0,WAIT1
	RET

DELAY:	
	MOV R0,SET_DELAY
DELAYX1:
	MOV R1,#1D
	DJNZ R1,$
	DJNZ R0,DELAYX1
	RET


DELAY_255:
	MOV R0,#255D
DELAY1:	MOV R1,#1D
	DJNZ R1,$
	DJNZ R0,DELAY1
	RET

DELAY_100:
	MOV R0,#100D
	DJNZ R0,$
	RET

DELAY_30:
	MOV R0,#30D
	DJNZ R0,$
	RET
DELAY_10:
	MOV R0,#10D
	DJNZ R0,$
	RET


TABULKA:
	DB	'JIRI BLECHA 24.12.2005 www.GeorgeB.wz.cz'

END
	








